#define SILENT_FAIL	1
#define	LOUD_FAIL	2

ini_handler
	var
		file
		file_text
		length

		error_mode = SILENT_FAIL

		list/sections[0]
		ini_handler/section/active

	Del()
		for(var/ini_handler/section/s in sections)
			del s

	proc
		SetErrorMode(m)
			error_mode = m

		Error(msg, position)
			if(error_mode == LOUD_FAIL)
				world.log << "INI Error"
				world.log << "  File: [file]"
				world.log << "  Error: [msg]"

				if(position)
					var/list/p = get_position_data(position)
					world.log << "  Line: [p[1]]"
					world.log << "  Column: [p[2]]"

			del src

		get_position_data(n)
			// The first index is the row, the second is the
			// column, and the third is the column with the
			// incorrect location highlighted.
			. = list(0, 0, 0)

			var
				p = 1
				q = 1
			do
				p = q
				.[1] ++

				q = findtext(file_text, "\n", q + 1)
			while(q && q <= n)

			.[2] = n - p + 1

			.[3] = copytext(file_text, p, findtext(file_text, "\n", p + 1))
			.[3] = html_encode(copytext(.[3], 1, .[2])) + "<b>" + html_encode(copytext(.[3], .[2], .[2] + 1)) + "</b>" + \
				html_encode(copytext(.[3], .[2] + 1))

		GetSection(s)
			return (s in sections) ? sections[s] : null

		GetSections()
			. = list()
			for(var/a in sections)
				. += sections[a]

		GetAttributes(s)
			var/ini_handler/section/section = GetSection(s)
			return section.GetAttributes()

		GetAttribute(s, a)
			var/ini_handler/section/section = GetSection(s)
			if(!section)
				return null

			return section.GetAttributeValue(a)

		SetAttribute(s, a, d)
			var/ini_handler
				section/section = GetSection(s)
				attribute/attribute
			if(!section)
				return 0

			attribute = section.GetAttribute(a)
			if(!attribute)
				return 0

			return attribute.SetData(d)