ini_handler/section
	parent_type = /datum

	var
		ini_handler
			master
			attribute/active
		list
			attributes[0]
		name

	New(ini_handler/m, n)
		SetMaster(m)
		SetName(n)

	Del()
		for(var/a in attributes)
			del attributes[a]

	proc
		SetMaster(ini_handler/m)
			master = m
			return 1

		HasAttribute(attr)
			return (attr in attributes)

		GetAttributes()
			. = list()
			for(var/a in attributes)
				. = attributes[a]

		GetAttribute(attr)
			if(!HasAttribute(attr))
				return null

			return attributes[attr]

		GetAttributeValue(attr)
			var/ini_handler/attribute/a = GetAttribute(attr)
			if(!a)
				return null

			return a.GetData()

		AddAttribute(attr, value)
			if(HasAttribute(attr))
				active = GetAttribute(attr)
				return 0

			active = new(value, src)
			attributes[attr] = active
			return 1

		SetValue(value)
			if(active)
				return active.SetData(value)

			return 0

		RemoveAttribute(attr)
			if(!HasAttribute(attr))
				return 0

			var/ini_handler/attribute/a = GetAttribute(attr)
			del a
			attributes -= attr

			return 1

		SetAttribute(attr, value)
			if(!HasAttribute(attr))
				return 0

			var/ini_handler/attribute/a = GetAttribute(attr)
			return a.SetData(value)

		SetName(n)
			name = n
			return 1

		GetName()
			return name